#include <stdint.h>
#include "delay.h"

#define delay280ns()
#define delay40us()
#define delay100us()				delayms( 1 )
#define delay1600us()				delayms( 2 )


#ifndef SC1602BS_8BIT
static volatile uint8_t __at (0xf200)	m_data ;
#else
#endif/*SC1602BS_8BIT*/


/* -------------------------------------------------------------------------------- */
/*   ʂSrbg                                                           */
/*                                                                                  */
/*   IN : data = f[^                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
static void write4( uint8_t data )
{
#ifndef SC1602BS_8BIT
	m_data = (data >> 4) | 0x80 ;
	m_data = (data >> 4) ;
#else
#endif/*SC1602BS_8BIT*/
}


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : rs = WX^I                                                         */
/*        db = f[^                                                               */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void sc1602bs_init( void )
{
	/* 15ms ҂ */
	delayms( 15 ) ;

	/* 0x3-  */
	write4( 0x30 ) ;

	/* 4.1ms ҂ */
	delayms( 5 ) ;

	/* 0x3-  */
	write4( 0x30 ) ;

	/* 100us ҂ */
	delay100us() ;

	/* 0x3-  */
	write4( 0x30 ) ;

	/* 40us ҂ */
	delay40us() ;

	/* 0x2-  */
	write4( 0x20 ) ;

	/* 40us ҂ */
	delay40us() ;
}


/* -------------------------------------------------------------------------------- */
/*   f[^                                                                 */
/*                                                                                  */
/*   IN : data = f[^                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void _sc1602bs_writeData( uint16_t data )
{

#ifndef SC1602BS_8BIT
	uint8_t		ers, value ;


	ers = ((uint8_t )(data >> 4) & 0xf0) | 0x80 ;

	/* ʂSrbg */
	value  = (uint8_t )data >> 4 ;
	m_data = value | ers ;
	m_data = value ;

	/* ʂSrbg */
	value  = (uint8_t )data & 15 ;
	m_data = value | ers ;
	m_data = value ;
#else
#endif/*SC1602BS_8BIT*/

	/* 280ns ҂ */
	delay280ns() ;
}


/* -------------------------------------------------------------------------------- */
/*   f[^݁i҂j                                                     */
/*                                                                                  */
/*   IN : data = f[^                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void _sc1602bs_writeDataWait( uint16_t data )
{
	_sc1602bs_writeData( data ) ;
	delay1600us() ;
}
